module Organizer
	class Event
		attr_reader :name, :description, :start, :end, :online_event, :currency, :listed
		attr_writer :online_event, :currency, :listed, :status

	   	def initialize(params={})
			params.each do |attr, value|
				self.public_send("#{attr}=", value)
			end
	    end

	    def name=(arg)
			raise "Expecting a String, got: #{arg.inspect}" unless arg.kind_of?(String)
			@name = {
				html: arg
			}
		end

		def description=(arg)
			raise "Expecting a String, got: #{arg.inspect}" unless arg.kind_of?(String)
			@description = {
				html: arg
			}
		end

		def start=(arg)
			raise "Expecting a Time, got: #{arg.inspect}" unless arg.kind_of?(Time)
			@start = {
				timezone: Time.zone.tzinfo.name,
				utc: arg.utc.iso8601
			}
		end

		def end=(arg)
			raise "Expecting a Time, got: #{arg.inspect}" unless arg.kind_of?(Time)
			@end = {
				timezone: Time.zone.tzinfo.name,
				utc: arg.utc.iso8601
			}
		end
	end
end